"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  deepMerge: () => deepMerge
});
module.exports = __toCommonJS(src_exports);

// src/merge.ts
function deepMerge(target, ...sources) {
  const options = { clone: false };
  function isObject(item) {
    return item !== null && typeof item === "object" && !Array.isArray(item);
  }
  function mergeObject(targetObj, sourceObj) {
    if (!isObject(sourceObj))
      return sourceObj;
    let merged;
    if (options.clone) {
      merged = __spreadValues({}, targetObj);
    } else {
      merged = targetObj;
    }
    for (const key of Object.keys(sourceObj)) {
      if (isObject(sourceObj[key])) {
        if (!merged[key]) {
          merged[key] = {};
        }
        merged[key] = mergeObject(
          merged[key],
          sourceObj[key]
        );
      } else {
        merged[key] = sourceObj[key];
      }
    }
    return merged;
  }
  let result = target;
  for (const source of sources) {
    if (source) {
      result = mergeObject(result, source);
    }
  }
  return result;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  deepMerge
});
